# disable FHS22 checks for /opt
#!BuildIgnore: post-build-checks

%{!?_initddir: %{expand: %%global _initddir %{_initrddir}}}

Name:           mhvtl
Version:        1.5.git.1457579227.c7ccb7a
Release:        2.1%{?dist}
License:        GPL
Summary:        Virtual tape library, kernel pseudo HBA driver
Url:            http://sites.google.com/site/linuxvtl2/
Group:          System/Kernel
Source0:        %{name}-%{version}.tar.bz2
Source1:        permissions
Source2:        permissions.paranoid
Source3:        tapeexerciser.1
Source4:        dump_tape.1
Source5:        make_vtl_media.1
%if 0%{?suse_version}
PreReq:         permissions
%endif
# PATCH-FIX-UPSTREAM requiredstop.patch
Patch0:         Makefile.patch
Patch1:         requiredstop.patch
Requires:       mhvtl-kmp
Requires:       module-init-tools
Requires:       procps
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

BuildRequires:  module-init-tools
BuildRequires:  procps
BuildRequires:  zlib-devel
BuildRequires:  lzo-devel

%if 0%{?suse_version}
BuildRequires:  kernel-source
BuildRequires:  kernel-syms
BuildRequires:  module-init-tools
BuildRequires:  help2man
%else
BuildRequires:  kernel-devel
%endif

%if 0%{?suse_version}
   %if 0%{?suse_version} == 1110
      %suse_kernel_module_package kdump ec2 um -p %_sourcedir/preamble
   %else
      %suse_kernel_module_package kdump um  -p %_sourcedir/preamble
   %endif
%endif

%description
A Virtual tape library and tape drives:

Used to emulate hardware robot & tape drives:

VTL consists of a pseudo HBA kernel driver and user-space daemons which
function as the SCSI target.

Communication between the kernel module and the daemons is achieved
via /dev/mhvtl? device nodes.

The kernel module is based on the scsi_debug driver.
The SSC/SMC target daemons have been written from scratch.

Note: Currently, the kernel module needs to be built separately. For
      instructions install src.rpm and read the INSTALL file.


%package KMP
Summary:        Virtual tape library kernel driver
Group:          System/Kernel

%description KMP
mhvtl is a virtual tape library. This package contains the
Kernel Module for the virtual tape library mhvtl
This kernel modules provides a kernel pseudo HBA driver

%prep
%setup -q
#%patch0
%patch1

%build
make RPM_OPT_FLAGS="%{optflags}" MHVTL_HOME_PATH=/var/lib/mhvtl VERSION=%{version}.%{release} usr
make RPM_OPT_FLAGS="%{optflags}" MHVTL_HOME_PATH=/var/lib/mhvtl VERSION=%{version}.%{release} etc
make RPM_OPT_FLAGS="%{optflags}" MHVTL_HOME_PATH=/var/lib/mhvtl VERSION=%{version}.%{release} scripts

cd man; make; cd -

#set -- *
mv kernel source
mkdir obj

export EXTRA_CFLAGS='-DVERSION=\"%{version}\"'
for flavor in %flavors_to_build; do
    rm -rf obj/$flavor
    cp -r source obj/$flavor
    make -C /usr/src/linux-obj/%_target_cpu/$flavor modules \
        M=$PWD/obj/$flavor \
        KSRC=/usr/src/linux-obj/%_target_cpu/$flavor
done

%install

export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=updates
for flavor in %flavors_to_build; do
    make -C /usr/src/linux-obj/%_target_cpu/$flavor modules_install \
         M=$PWD/obj/$flavor
done

%ifarch x86_64 amd64 ppc64
mkdir -p %{buildroot}/usr/lib64
%else
mkdir -p %{buildroot}/usr/lib
%endif

install -dm 0755 %{buildroot}%{_var}/lib/mhvtl
install -dm 0755 %{buildroot}%{_sbindir}
install -dm 0755  %{buildroot}%{_sysconfdir}/permissions.d
install -Dm 0750 etc/mhvtl %{buildroot}%{_initddir}/mhvtl
install -Dm 0750 -s usr/vtltape %{buildroot}%{_bindir}/vtltape
install -Dm 0750 -s usr/vtllibrary %{buildroot}%{_bindir}/vtllibrary
install -Dm 0750 usr/vtlcmd %{buildroot}%{_bindir}/vtlcmd
install -Dm 0750 usr/mktape %{buildroot}%{_bindir}/mktape
install -Dm 0750 usr/dump_tape %{buildroot}%{_bindir}/dump_tape
install -Dm 0750 usr/edit_tape %{buildroot}%{_bindir}/edit_tape
install -Dm 0700 usr/build_library_config %{buildroot}%{_bindir}/build_library_config
install -Dm 0700 usr/make_vtl_media %{buildroot}%{_bindir}/make_vtl_media
install -Dm 0700 usr/tapeexerciser %{buildroot}%{_bindir}/tapeexerciser

%ifarch x86_64 amd64 ppc64
install -m 755 usr/libvtlscsi.so %{buildroot}/usr/lib64/libvtlscsi.so
install -m 755 usr/libvtlcart.so %{buildroot}/usr/lib64/libvtlcart.so
%else
install -m 755 usr/libvtlscsi.so %{buildroot}/usr/lib/libvtlscsi.so
install -m 755 usr/libvtlcart.so %{buildroot}/usr/lib/libvtlcart.so
%endif

install -Dm 0644 man/build_library_config.1 %{buildroot}%{_mandir}/man1/build_library_config.1
install -Dm 0644 man/edit_tape.1 %{buildroot}%{_mandir}/man1/edit_tape.1
install -Dm 0644 man/mktape.1 %{buildroot}%{_mandir}/man1/mktape.1
install -Dm 0644 man/mhvtl.1 %{buildroot}%{_mandir}/man1/mhvtl.1
install -Dm 0644 man/vtlcmd.1 %{buildroot}%{_mandir}/man1/vtlcmd.1
install -Dm 0644 man/vtllibrary.1 %{buildroot}%{_mandir}/man1/vtllibrary.1
install -Dm 0644 man/vtltape.1 %{buildroot}%{_mandir}/man1/vtltape.1
install -m 0644 %{S:3} %{buildroot}%{_mandir}/man1/tapeexerciser.1
install -m 0644 %{S:4} %{buildroot}%{_mandir}/man1/dump_tape.1
install -m 0644 %{S:5} %{buildroot}%{_mandir}/man1/make_vtl_media.1
install -Dm 0644 man/library_contents.5 %{buildroot}%{_mandir}/man5/library_contents.5
install -Dm 0644 man/device.conf.5 %{buildroot}%{_mandir}/man5/device.conf.5
install -m 0644 %{S:1} %{buildroot}%{_sysconfdir}/permissions.d/%{name}
install -m 0644 %{S:2} %{buildroot}%{_sysconfdir}/permissions.d/%{name}.paranoid
ln -s %{_initddir}/mhvtl %{buildroot}%{_sbindir}/rcmhvtl

%if 0%{?suse_version} >= 1120
%verifyscript
%verify_permissions -e %{_bindir}/vtltape
%verify_permissions -e %{_bindir}/vtllibrary
%verify_permissions -e %{_var}/lib/mhvtl/
%endif

rm -f INSTALL README etc/library_contents.sample

%pre
if ! getent group vtl > /dev/null 2>&1; then
   groupadd -r vtl
fi
if ! getent passwd vtl > /dev/null 2>&1; then
   useradd -r -g vtl -c "VTL daemon" -d %{_var}/lib/mhvtl -s /bin/bash vtl
fi
if [ -x /etc/init.d/mhvtl ]; then
 /etc/init.d/mhvtl shutdown
fi

%post
%if 0%{?set_permissions:1} > 0
    %set_permissions %{name}
    %set_permissions %{_bindir}/vtltape
    %set_permissions %{_bindir}/vtllibrary
    %set_permissions %{_var}/lib/mhvtl/
%else
    %run_permissions
%endif
/sbin/ldconfig
/sbin/chkconfig --check mhvtl 2> /dev/null
if [ $? -eq 1 ]; then
	/sbin/chkconfig --add mhvtl
	/sbin/chkconfig mhvtl on
fi

%preun
%stop_on_removal %{name}
if [ -x %{_initddir}/mhvtl ]; then
 %{_initddir}/mhvtl shutdown
fi

%postun
/sbin/ldconfig
%insserv_cleanup

%files
%defattr(755,root,root,-)
#doc attr(644,root,root) INSTALL README etc/library_contents.sample
%{_initddir}/mhvtl
%{_bindir}/vtlcmd
%verify(not user group mode) %attr(4750, root, vtl) %{_bindir}/vtltape
%verify(not user group mode) %attr(4750, root, vtl) %{_bindir}/vtllibrary
%verify(not user group mode) %attr(2750, vtl, vtl) %{_var}/lib/mhvtl/
%{_bindir}/mktape
%{_bindir}/dump_tape
%{_bindir}/tapeexerciser
%{_bindir}/build_library_config
%{_bindir}/make_vtl_media
%{_bindir}/edit_tape
%{_sbindir}/rcmhvtl
%ifarch x86_64 amd64 ppc64
/usr/lib64/libvtlscsi.so
/usr/lib64/libvtlcart.so
%else
/usr/lib/libvtlscsi.so
/usr/lib/libvtlcart.so
%endif
%doc %attr(644,root,root) %{_mandir}/man1/*
%doc %attr(644,root,root) %{_mandir}/man5/*
%config %attr(644,root,root) %{_sysconfdir}/permissions.d/%{name}
%config %attr(644,root,root) %{_sysconfdir}/permissions.d/%{name}.paranoid
#### config files should be noted here but software by 
#### itself creates them so i do not know what to do
#%%config(noreplace) %%{_sysconfdir}/mhvtl/mhvtl.conf
#%%config(noreplace) %%{_sysconfdir}/mhvtl/device.conf
#%%config(noreplace) %%{_sysconfdir}/mhvtl/library_contents.*

%changelog
